NonLoginAuthenticator (Apache Tomcat 9.0.120 API Documentation)
Description: declaration: package: org.apache.catalina.authenticator, class: NonLoginAuthenticator

# Class NonLoginAuthenticator

java.lang.Object
org.apache.catalina.util.LifecycleBase
org.apache.catalina.util.LifecycleMBeanBase
org.apache.catalina.valves.ValveBase
org.apache.catalina.authenticator.AuthenticatorBase
org.apache.catalina.authenticator.NonLoginAuthenticator

All Implemented Interfaces:
  `MBeanRegistration, RegistrationListener, Authenticator, Contained, JmxEnabled, Lifecycle, Valve`

public final class NonLoginAuthenticator extends AuthenticatorBase
An Authenticator and Valve implementation that checks only security constraints not involving user authentication.

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class AuthenticatorBase

  `AuthenticatorBase.AllowCorsPreflight, AuthenticatorBase.SsoReauthenticationMode`

  ### Nested classes/interfaces inherited from interface Lifecycle

  `Lifecycle.SingleUse`

- ## Field Summary

  ### Fields inherited from class AuthenticatorBase

  `alwaysUseSession, AUTH_HEADER_NAME, cache, changeSessionIdOnAuthentication, context, disableProxyCaching, jaspicCallbackHandlerClass, REALM_NAME, securePagesWithPragma, secureRandomAlgorithm, secureRandomClass, secureRandomProvider, sendAuthInfoResponseHeaders, sessionIdGenerator, sm, sso`

  ### Fields inherited from class ValveBase

  `asyncSupported, container, containerLog, next`

  ### Fields inherited from class LifecycleMBeanBase

  `mserver`

  ### Fields inherited from interface Lifecycle

  `AFTER_DESTROY_EVENT, AFTER_INIT_EVENT, AFTER_START_EVENT, AFTER_STOP_EVENT, BEFORE_DESTROY_EVENT, BEFORE_INIT_EVENT, BEFORE_START_EVENT, BEFORE_STOP_EVENT, CONFIGURE_START_EVENT, CONFIGURE_STOP_EVENT, PERIODIC_EVENT, START_EVENT, STOP_EVENT`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `NonLoginAuthenticator()`
  Constructs a new NonLoginAuthenticator.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected boolean`
  `doAuthenticate(Request request, HttpServletResponse response)`
  Authenticate the user making this request, based on the fact that no `login-config` has been defined for the container.
  `protected String`
  `getAuthMethod()`
  Return the authentication method, which is vendor-specific and not defined by HttpServletRequest.

  ### Methods inherited from class AuthenticatorBase

  `allowCorsPreflightBypass, associate, authenticate, changeSessionID, checkForCachedAuthentication, doLogin, getAllowCorsPreflight, getAlwaysUseSession, getCache, getChangeSessionIdOnAuthentication, getContainer, getDisableProxyCaching, getJaspicCallbackHandlerClass, getRealmName, getSecurePagesWithPragma, getSecureRandomAlgorithm, getSecureRandomClass, getSecureRandomProvider, getSsoReauthenticationMode, invoke, isContinuationRequired, isPreemptiveAuthPossible, isSendAuthInfoResponseHeaders, login, logout, notify, reauthenticateFromSSO, register, register, setAllowCorsPreflight, setAlwaysUseSession, setCache, setChangeSessionIdOnAuthentication, setContainer, setDisableProxyCaching, setJaspicCallbackHandlerClass, setSecurePagesWithPragma, setSecureRandomAlgorithm, setSecureRandomClass, setSecureRandomProvider, setSendAuthInfoResponseHeaders, setSsoReauthenticationMode, startInternal, stopInternal`

  ### Methods inherited from class ValveBase

  `backgroundProcess, getDomainInternal, getNext, getObjectNameKeyProperties, initInternal, isAsyncSupported, setAsyncSupported, setNext, toString`

  ### Methods inherited from class LifecycleMBeanBase

  `destroyInternal, getDomain, getObjectName, postDeregister, postRegister, preDeregister, preRegister, register, setDomain, unregister, unregister`

  ### Methods inherited from class LifecycleBase

  `addLifecycleListener, destroy, findLifecycleListeners, fireLifecycleEvent, getState, getStateName, getThrowOnFailure, init, removeLifecycleListener, setState, setState, setThrowOnFailure, start, stop`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### NonLoginAuthenticator

    public NonLoginAuthenticator()
    Constructs a new NonLoginAuthenticator.

- ## Method Details

  - ### doAuthenticate

    protected boolean doAuthenticate(Request request, HttpServletResponse response) throws IOException

    Authenticate the user making this request, based on the fact that no `login-config` has been defined for the container.

    This implementation means "login the user even though there is no self-contained way to establish a security Principal for that user".

    This method is called by the AuthenticatorBase super class to establish a Principal for the user BEFORE the container security constraints are examined, i.e. it is not yet known whether the user will eventually be permitted to access the requested resource. Therefore, it is necessary to always return `true` to indicate the user has not failed authentication.

    There are two cases:

    - without SingleSignon: a Session instance does not yet exist and there is no `auth-method` to authenticate the user, so leave Request's Principal as null. Note: AuthenticatorBase will later examine the security constraints to determine whether the resource is accessible by a user without a security Principal and Role (i.e. unauthenticated).
    - with SingleSignon: if the user has already authenticated via another container (using its own login configuration), then associate this Session with the SSOEntry so it inherits the already-established security Principal and associated Roles. Note: This particular session will become a full member of the SingleSignOnEntry Session collection and so will potentially keep the SSOE "alive", even if all the other properly authenticated Sessions expire first... until it expires too.
    Specified by:
      `doAuthenticate` in class `AuthenticatorBase`
    Parameters:
      `request` - Request we are processing
      `response` - Response we are creating
    Returns:
      boolean to indicate whether the user is authenticated
    Throws:
      `IOException` - if an input/output error occurs

  - ### getAuthMethod

    protected String getAuthMethod()
    Description copied from class: `AuthenticatorBase`
    Return the authentication method, which is vendor-specific and not defined by HttpServletRequest.
    Specified by:
      `getAuthMethod` in class `AuthenticatorBase`
    Returns:
      the authentication method, which is vendor-specific and not defined by HttpServletRequest.